/*
   Komendy MEM_SET, MEM_COPY
   UWAGA: Funkcje operuj  na pamieci uzytkownika modbus $X 
   Adres typu SHORT INTEGER (2 bajty). 

   MEM_COPY(DEST,SRC,NUM)  - kopiowanie pamieci uzytkownika 
   DEST - adres pamieci uzytkownika do ktorego dane beda kopiowane
   SRC - adres pamieci uzytkownika z ktorego dane beda kopiowane 
   NUM - ilosc rejestrow do skopiowania (rejestry 2-bajtowe)
   np.:
   MEM_COPY(0,1000,100) - skopiowanie 100 rejestrow uzytkownika (2-bajtowych) z adresu 1000 do adresu 0.
   
   MEM_SET(A,VAL,C)   - ustawienie pamieci uzytkownika 
   DEST - adres pamieci uzytkownika od ktorego dane beda ustawiane
   VAL - wartosc do ustawienia (integer 0...65535)
   NUM - ilosc rejestrow do ustawienia (rejestry 2-bajtowe)
   np.:
   MEM_SET(200, 0, 100) - ustawienie wartosci 0 w 100 kolejnych rejestrach poczawszy od adresu 100 

*/



MEM_SET(0, 0xABCD, 10)     // Ustawienie wartosci 0xABCD (wartosc hex) w 100 kolejnych rejestrach ($I0...$I99)
MEM_COPY(500, 0, 100)      // Skopiowanie 100 kolejnych rejestrow spod adresu 0 do adresu 500 

SET mem1 = 0
SET mem2 = 0
OUT1 = OFF

MAIN:
    SET A = 0
    WHILE A < 100
        SET MEM_INDEX = A      
        mem1 = MEM_INT0             // wartosc z pamieci o adresie A
        SET MEM_INDEX = A + 500
        mem2 = MEM_INT0             // wartosc z pamieci o adresie A + 500
      
        IF mem1!=mem2               // sprawdzenie czy mem1[A] == mem2[A+500]
            OUT1 = ON
            DELAY 10                // BLAD -  rozne  wartosci                      
        ENDIF
    ENDWHILE

JUMP MAIN



















