/*
 Data: 19-4-2016

 Zmienne uzytkownika z dostpem przez MODBUS

 Opis: MIC488 posiada przestrzen pamieci, do ktrej mamy dostp z zewntrznych urzdzen
 przez MODBUS (MIC488 pracuje jako urzdzenie SLAVE, a zewntrzne urzdzenie jako MASTER)

 
 ============ Adresowanie pamici uzytkownika: ==============================
 - $IXX - wartosc typu INT
 - $DXX - wartosc typu DINT
 - $RIXX - wartosc typu REAL

 ,gdzie XX - adres pamieci uzytkownika 0...500 
 np. SET $I10 = 123     // Zapisanie do rejestru 10 wartosci 123    (typu INT)
     SET $R50 = 40.25   // Zapisanie do rejestru 50 wartosci 50.25  (typu REAL)

 UWAGA: Rejestry typu DINT oraz REAL zajmuja zawsze dwie komorki pamici. Musz  byc
        zapisywane jako wartosci parzyste:

        $D20 - Zapisanie poprawny, $D21 - Zapisanie bdny!!!   

 ========== Dostp do pamieci przez rejestry indeksowane MEM_XXXX =======================
 Dostep do pamieci uzytkownika mozliwy jest takze przez ponizsze rejestry:
 
 MEM_INTXX      - dla wartosc typu INT
 MEM_DINTXX     - dla wartosc typu DINT
 MEM_REALXX     - dla wartosc typu REAL

 MEM_INDEX      - index przesuniecia dla pamieci MEM_XXXX
 
 gdzie XX - adres pamieci uzytkownika 0...500 
 np.

 SET MEM_INT10  = 123       // Zapisanie do rejestru 10 wartosci 123    (typu INT)
 SET MEM_REAL50 = 40.25     // Zapisanie do rejestru 50 wartosci 50.25  (typu REAL)

  ============== Indexowanie pamieci uzytkownika  ==========================

  Za pomoc rejestru MEM_INDEX mozliwe jest indeksowanie pamieci rejestrow uzytkownika np: 

  SET MEM_INDEX = 0
  
  SET MEM_INT0 = 1
  SET MEM_INT1 = 2
  SET MEM_INT2 = 3
  SET MEM_INT3 = 4
  SET MEM_INT4 = 5

  SET MEM_INDEX = 2    // Przesuniecie pamieci o 2 do przodu

  Wwczas:
  
  MEM_INT(0 + MEM_INDEX) ->  MEM_INT2 == 3
  MEM_INT(1 + MEM_INDEX) ->  MEM_INT3 == 4
  MEM_INT(2 + MEM_INDEX) ->  MEM_INT4 == 5
  MEM_INT(3 + MEM_INDEX) ->  MEM_INT5 == ??
  MEM_INT(4 + MEM_INDEX) ->  MEM_INT6 == ??
  
*/

SET NUMER_POZYCJI = 0
SET M1 = ON
SET M2 = ON
SET AccM1 = 400
SET AccM1 = 400
SET DecM1 = 400
SET DecM2 = 400
SET VmaxM1 = 10
SET VmaxM2 = 10

SET PosM1 = 0
SET PosM2 = 0

// Przykladowe dane
SET MEM_INDEX = 0
SET MEM_INT0 = 10
SET MEM_INT1 = 15
SET MEM_INT2 = 14
SET MEM_INT3 = 20
SET MEM_INT4 = 25
SET MEM_INT5 = 30
SET MEM_INT6 = 40
SET MEM_INT7 = 50
SET MEM_INT8 = 55
SET MEM_INT9 = 65



MAIN:
    
    // Zapisanie do rejestru uzytkownika o adresie 2 wartosci 3200
    SET $I40 = 3200
    // lub (gdy MEM_INDEX = 0)
    SET MEM_INT40 = 3200

    // Zapisanie do rejestru uzytkownika o adresie 20 wartosci 250400 
    SET $D42 = 250000 
    // lub (gdy MEM_INDEX = 0)
    SET MEM_DINT42 = 250400
    
    // Zapisanie do rejestru uzytkownika o adresie 50 wartosci 123.456 
    SET $R44 = 123.456
    // lub  (gdy MEM_INDEX = 0)
    SET MEM_REAL44 = 123.456
    

    DELAY 1
    JUMP DO_POINT
    SET NUMER_POZYCJI = NUMER_POZYCJI + 2 
    IF NUMER_POZYCJI > 9
        NUMER_POZYCJI = 0
    ENDIF
    
JUMP MAIN


// Przykladowa funkcja wykonujaca ruch do punktow X/Y (z wykorzystaniem interpolacji liniowej)
// na podstawnie danych z pamieci uzytkownika (indeksowanej)
DO_POINT:

    SET MEM_INDEX = NUMER_POZYCJI
    SET LinX = MEM_INT0             // Punkt X - z pamieci indeksowanej  
    SET LinY = MEM_INT1             // Punkt Y - z pamieci indeksowanej
    SET LinVel = 5                 // Predkosc ruchu liniowego 20
    MOVELIN 0
    WAITPOS

RETURN



















